Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -10515,92 +10819,9 @@
     temp_bin  = 0.0_wp
 
-    SELECT CASE ( TRIM( variable ) )
-
-       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
-          IF ( av == 0 )  THEN
-             IF ( TRIM( variable ) == 'g_H2SO4')  found_index = 1
-             IF ( TRIM( variable ) == 'g_HNO3')   found_index = 2
-             IF ( TRIM( variable ) == 'g_NH3')    found_index = 3
-             IF ( TRIM( variable ) == 'g_OCNV')   found_index = 4
-             IF ( TRIM( variable ) == 'g_OCSV')   found_index = 5
-
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( salsa_gas(found_index)%conc(k,j,i),                 &
-                                               REAL( fill_value, KIND = wp ),                      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             IF ( TRIM( variable(3:) ) == 'H2SO4' ) to_be_resorted => g_h2so4_av
-             IF ( TRIM( variable(3:) ) == 'HNO3' )  to_be_resorted => g_hno3_av
-             IF ( TRIM( variable(3:) ) == 'NH3' )   to_be_resorted => g_nh3_av
-             IF ( TRIM( variable(3:) ) == 'OCNV' )  to_be_resorted => g_ocnv_av
-             IF ( TRIM( variable(3:) ) == 'OCSV' )  to_be_resorted => g_ocsv_av
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,            &
-                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       CASE ( 'LDSA' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-!
-!--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
-!
-!--                      Deposition factor: alveolar
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
-                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
-                                1.362_wp )**2 ) )
-!
-!--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
-!
-!--                      Lung-deposited surface area LDSA (units mum2/cm3)
-                         temp_bin = temp_bin + pi * mean_d**2 * df * nc 
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( ldsa_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',      &
-              'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
-          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
-          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
-          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
-          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
-          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
-          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
-          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
-          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
-          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
-          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
-          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
-
+    IF ( variable(7:11) == 'N_bin' )  THEN
+       READ( variable(12:),* ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+
+          ib = char_to_int
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -10622,45 +10843,11 @@
              ENDDO
           ENDIF
-
-       CASE ( 'Ntot' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( ntot_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',      &
-              'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
-          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
-          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
-          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
-          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
-          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
-          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
-          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
-          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
-          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
-          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
-          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
-
+       ENDIF
+
+    ELSEIF ( variable(7:11) == 'm_bin' )  THEN
+       READ( variable(12:),* ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+
+          ib = char_to_int
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -10686,66 +10873,258 @@
              ENDDO
           ENDIF
-
-       CASE ( 'PM2.5' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+       ENDIF
+
+    ELSE
+       SELECT CASE ( TRIM( variable(7:) ) )
+
+          CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
+             IF ( av == 0 )  THEN
+                IF ( TRIM( variable(7:) ) == 'g_H2SO4')  found_index = 1
+                IF ( TRIM( variable(7:) ) == 'g_HNO3')   found_index = 2
+                IF ( TRIM( variable(7:) ) == 'g_NH3')    found_index = 3
+                IF ( TRIM( variable(7:) ) == 'g_OCNV')   found_index = 4
+                IF ( TRIM( variable(7:) ) == 'g_OCSV')   found_index = 5
+
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( salsa_gas(found_index)%conc(k,j,i),              &
+                                                  REAL( fill_value, KIND = wp ),                   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+!
+!--             9: remove salsa_g_ from the beginning
+                IF ( TRIM( variable(9:) ) == 'H2SO4' ) to_be_resorted => g_h2so4_av
+                IF ( TRIM( variable(9:) ) == 'HNO3' )  to_be_resorted => g_hno3_av
+                IF ( TRIM( variable(9:) ) == 'NH3' )   to_be_resorted => g_nh3_av
+                IF ( TRIM( variable(9:) ) == 'OCNV' )  to_be_resorted => g_ocnv_av
+                IF ( TRIM( variable(9:) ) == 'OCSV' )  to_be_resorted => g_ocsv_av
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,         &
+                                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'LDSA' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+   !
+   !--                      Diameter in micrometres
+                            mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+   !
+   !--                      Deposition factor: alveolar
+                            df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +    &
+                                   2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -  &
+                                   1.362_wp )**2 ) )
+   !
+   !--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                            temp_bin = temp_bin + pi * mean_d**2 * df * 1.0E-6_wp *                &
+                                       aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( ldsa_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'N_UFP' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( nufp_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'Ntot' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( ntot_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'PM0.1' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( pm01_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'PM2.5' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( pm25_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 'PM10' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( pm10_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
+             IF ( is_used( prtcl, TRIM( variable(9:) ) ) )  THEN  ! 9: remove salsa_s_
+                found_index = get_index( prtcl, TRIM( variable(9:) ) )
+                IF ( av == 0 )  THEN
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb_do, nzt_do
+                            temp_bin = 0.0_wp
+                            DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
                                temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
-                         ENDIF
+                            local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),      &
+                                                     BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                         ENDDO
                       ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( pm25_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                ELSE
+!
+!--                9: remove salsa_s_ from the beginning
+                   IF ( TRIM( variable(9:) ) == 'BC' )   to_be_resorted => s_bc_av
+                   IF ( TRIM( variable(9:) ) == 'DU' )   to_be_resorted => s_du_av
+                   IF ( TRIM( variable(9:) ) == 'NH' )   to_be_resorted => s_nh_av
+                   IF ( TRIM( variable(9:) ) == 'NO' )   to_be_resorted => s_no_av
+                   IF ( TRIM( variable(9:) ) == 'OC' )   to_be_resorted => s_oc_av
+                   IF ( TRIM( variable(9:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                   IF ( TRIM( variable(9:) ) == 'SS' )   to_be_resorted => s_ss_av
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb_do, nzt_do
+                            local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,      &
+                                                     KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                         ENDDO
+                      ENDDO
                    ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       CASE ( 'PM10' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
-                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( pm10_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
-          IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-             found_index = get_index( prtcl, TRIM( variable(3:) ) )
+                ENDIF
+             ENDIF
+
+          CASE ( 's_H2O' )
+             found_index = get_index( prtcl, 'H2O' )
              IF ( av == 0 )  THEN
                 DO  i = nxl, nxr
@@ -10762,11 +11141,5 @@
                 ENDDO
              ELSE
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av
+                to_be_resorted => s_h2o_av
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -10778,37 +11151,10 @@
                 ENDDO
              ENDIF
-          ENDIF
-
-       CASE ( 's_H2O' )
-          found_index = get_index( prtcl, 'H2O' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
-                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             to_be_resorted => s_h2o_av
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,            &
-                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       CASE DEFAULT
-          found = .FALSE.
-
-    END SELECT
+
+          CASE DEFAULT
+             found = .FALSE.
+
+       END SELECT
+    ENDIF
 
  END SUBROUTINE salsa_data_output_3d
@@ -10837,117 +11183,39 @@
     CHARACTER(LEN=7) ::  vari      !< trimmed format of variable
 
-    INTEGER(iwp) ::  av              !<
-    INTEGER(iwp) ::  found_index     !< index of a chemical compound
-    INTEGER(iwp) ::  ib              !< loop index for aerosol size number bins
-    INTEGER(iwp) ::  ic              !< loop index for chemical components
-    INTEGER(iwp) ::  i               !< loop index in x-direction
-    INTEGER(iwp) ::  j               !< loop index in y-direction
-    INTEGER(iwp) ::  k               !< loop index in z-direction
+    INTEGER(iwp) ::  av             !<
+    INTEGER(iwp) ::  char_to_int    !< for converting character to integer
+    INTEGER(iwp) ::  found_index    !< index of a chemical compound
+    INTEGER(iwp) ::  ib             !< loop index for aerosol size number bins
+    INTEGER(iwp) ::  ic             !< loop index for chemical components
+    INTEGER(iwp) ::  i              !< loop index in x-direction
+    INTEGER(iwp) ::  j              !< loop index in y-direction
+    INTEGER(iwp) ::  k              !< loop index in z-direction
     INTEGER(iwp) ::  mid            !< masked output running index
-    INTEGER(iwp) ::  topo_top_ind    !< k index of highest horizontal surface
+    INTEGER(iwp) ::  topo_top_ind   !< k index of highest horizontal surface
 
     LOGICAL ::  found      !<
     LOGICAL ::  resorted   !<
 
-    REAL(wp) ::  df        !< For calculating LDSA: fraction of particles 
-                           !< depositing in the alveolar (or tracheobronchial)
-                           !< region of the lung. Depends on the particle size 
+    REAL(wp) ::  df        !< For calculating LDSA: fraction of particles depositing in the alveolar
+                           !< (or tracheobronchial) region of the lung. Depends on the particle size
     REAL(wp) ::  mean_d    !< Particle diameter in micrometres
-    REAL(wp) ::  nc        !< Particle number concentration in units 1/cm**3
     REAL(wp) ::  temp_bin  !< temporary array for calculating output variables
 
     REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  local_pf   !<
 
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), TARGET ::  temp_array  !< temporary array
+
     REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer
 
-    found     = .TRUE.
-    resorted  = .FALSE.
-    grid      = 's'
-    temp_bin  = 0.0_wp
-
-    SELECT CASE ( TRIM( variable ) )
-
-       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
-          vari = TRIM( variable )
-          IF ( av == 0 )  THEN
-             IF ( vari == 'g_H2SO4')  to_be_resorted => salsa_gas(1)%conc
-             IF ( vari == 'g_HNO3')   to_be_resorted => salsa_gas(2)%conc
-             IF ( vari == 'g_NH3')    to_be_resorted => salsa_gas(3)%conc
-             IF ( vari == 'g_OCNV')   to_be_resorted => salsa_gas(4)%conc
-             IF ( vari == 'g_OCSV')   to_be_resorted => salsa_gas(5)%conc
-          ELSE
-             IF ( vari == 'g_H2SO4') to_be_resorted => g_h2so4_av
-             IF ( vari == 'g_HNO3')  to_be_resorted => g_hno3_av
-             IF ( vari == 'g_NH3')   to_be_resorted => g_nh3_av
-             IF ( vari == 'g_OCNV')  to_be_resorted => g_ocnv_av
-             IF ( vari == 'g_OCSV')  to_be_resorted => g_ocsv_av
-          ENDIF
-
-       CASE ( 'LDSA' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nz_do3d
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-!
-!--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
-!
-!--                      Deposition factor: alveolar
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
-                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
-                                1.362_wp )**2 ) )
-!
-!--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
-!
-!--                      Lung-deposited surface area LDSA (units mum2/cm3)
-                         temp_bin = temp_bin + pi * mean_d**2 * df * nc
-                      ENDDO
-                      tend(k,j,i) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-             IF ( .NOT. mask_surface(mid) )  THEN   
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ELSE 
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
-                                                                  grid )
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
-                                                 mask_j(mid,j), mask_i(mid,i) )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-             resorted = .TRUE.
-          ELSE
-             to_be_resorted => ldsa_av
-          ENDIF
-
-       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6', 'N_bin7', 'N_bin8',   &
-              'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
-          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
-          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
-          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
-          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
-          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
-          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
-          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
-          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
-          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
-          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
-          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
-
+    found      = .TRUE.
+    resorted   = .FALSE.
+    grid       = 's'
+    temp_array = 0.0_wp
+    temp_bin   = 0.0_wp
+
+    IF ( variable(7:11) == 'N_bin' )  THEN
+       READ( variable(12:),* ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+          ib = char_to_int
           IF ( av == 0 )  THEN
              IF ( .NOT. mask_surface(mid) )  THEN
